<html>
<head>
<title>OgreShaderExNormalMapLighting.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderExNormalMapLighting.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderExNormalMapLighting_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderExNormalMapLighting_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderExNormalMapLighting_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_EXT_SHADERS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreShaderParameter_8h.html">OgreShaderParameter.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderSubRenderState_8h.html">OgreShaderSubRenderState.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreLight_8h.html">OgreLight.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 <span class="keyword">namespace </span>RTShader {
<a name="l00040"></a>00040 
<a name="l00048"></a>00048 <span class="preprocessor">#define SGX_LIB_NORMALMAPLIGHTING                   &quot;SGXLib_NormalMapLighting&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_CONSTRUCT_TBNMATRIX                &quot;SGX_ConstructTBNMatrix&quot;</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_TRANSFORMNORMAL                    &quot;SGX_TransformNormal&quot;</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_TRANSFORMPOSITION                  &quot;SGX_TransformPosition&quot;</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_FETCHNORMAL                        &quot;SGX_FetchNormal&quot;</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_DIRECTIONAL_DIFFUSE          &quot;SGX_Light_Directional_Diffuse&quot;</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_DIRECTIONAL_DIFFUSESPECULAR  &quot;SGX_Light_Directional_DiffuseSpecular&quot;</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_POINT_DIFFUSE                &quot;SGX_Light_Point_Diffuse&quot;</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_POINT_DIFFUSESPECULAR        &quot;SGX_Light_Point_DiffuseSpecular&quot;</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_SPOT_DIFFUSE                 &quot;SGX_Light_Spot_Diffuse&quot;</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#define SGX_FUNC_LIGHT_SPOT_DIFFUSESPECULAR         &quot;SGX_Light_Spot_DiffuseSpecular&quot;</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> NormalMapLighting : <span class="keyword">public</span> SubRenderState
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="comment">// Interface.</span>
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00069"></a>00069     NormalMapLighting();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType                 () <span class="keyword">const</span>;
<a name="l00075"></a>00075 
<a name="l00079"></a>00079     <span class="keyword">virtual</span> <span class="keywordtype">int</span>             getExecutionOrder       () <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00084"></a>00084     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            updateGpuProgramsParams (Renderable* rend, Pass* pass, <span class="keyword">const</span> AutoParamDataSource* source, <span class="keyword">const</span> <a class="code" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a>* pLightList);
<a name="l00085"></a>00085 
<a name="l00089"></a>00089     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            copyFrom                (<span class="keyword">const</span> SubRenderState&amp; rhs);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00095"></a>00095     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            preAddToRenderState     (<span class="keyword">const</span> RenderState* renderState, Pass* srcPass, Pass* dstPass);
<a name="l00096"></a>00096 
<a name="l00100"></a>00100     <span class="keywordtype">void</span>                    setTexCoordIndex        (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index) { mVSTexCoordSetIndex = index;}
<a name="l00101"></a>00101 
<a name="l00105"></a>00105     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>            getTexCoordIndex        ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVSTexCoordSetIndex; }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="comment">// Type of this render state.</span>
<a name="l00108"></a>00108     <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Type;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <span class="comment">// Normal map space definition.</span>
<a name="l00111"></a>00111     <span class="keyword">enum</span> NormalMapSpace
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113         NMS_TANGENT,        <span class="comment">// Normal map contains normal data in tangent space.</span>
<a name="l00114"></a>00114                             <span class="comment">// This is the default normal mapping behavior and it requires that the</span>
<a name="l00115"></a>00115                             <span class="comment">// target mesh will have valid tangents within its vertex data.</span>
<a name="l00116"></a>00116         
<a name="l00117"></a>00117         NMS_OBJECT          <span class="comment">// Normal map contains normal data in object local space.</span>
<a name="l00118"></a>00118                             <span class="comment">// This normal mapping technique has the advantages of better visualization results,</span>
<a name="l00119"></a>00119                             <span class="comment">// lack of artifacts that comes from texture mirroring usage, it doesn&#39;t requires tangent</span>
<a name="l00120"></a>00120                             <span class="comment">// and it also saves some instruction in the vertex shader stage.</span>
<a name="l00121"></a>00121                             <span class="comment">// The main drawback of using this kind of normal map is that the target object must be static</span>
<a name="l00122"></a>00122                             <span class="comment">// in terms of local space rotations and translations.</span>
<a name="l00123"></a>00123     };
<a name="l00124"></a>00124 
<a name="l00129"></a>00129     <span class="keywordtype">void</span>                    setNormalMapSpace           (NormalMapSpace normalMapSpace) { mNormalMapSpace = normalMapSpace; }
<a name="l00130"></a>00130 
<a name="l00132"></a>00132     NormalMapSpace          getNormalMapSpace           ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNormalMapSpace; }
<a name="l00133"></a>00133 
<a name="l00137"></a>00137     <span class="keywordtype">void</span>                    setNormalMapTextureName     (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; textureName) { mNormalMapTextureName = textureName; }
<a name="l00138"></a>00138 
<a name="l00142"></a>00142     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;           getNormalMapTextureName     ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNormalMapTextureName; }
<a name="l00143"></a>00143 
<a name="l00150"></a>00150     <span class="keywordtype">void</span>                    setNormalMapFiltering           (<span class="keyword">const</span> <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> minFilter, <span class="keyword">const</span> <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> magFilter, <span class="keyword">const</span> <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mipFilter) 
<a name="l00151"></a>00151     { mNormalMapMinFilter = minFilter; mNormalMapMagFilter = magFilter; mNormalMapMipFilter = mipFilter; }
<a name="l00152"></a>00152 
<a name="l00159"></a>00159     <span class="keywordtype">void</span>                    getNormalMapFiltering           (<a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>&amp; minFilter, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>&amp; magFilter, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>&amp; mipFilter)<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword">    </span>{ minFilter = mNormalMapMinFilter; magFilter = mNormalMapMagFilter ; mipFilter = mNormalMapMipFilter; }
<a name="l00161"></a>00161 
<a name="l00165"></a>00165     <span class="keywordtype">void</span>            setNormalMapAnisotropy      (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> anisotropy) { mNormalMapAnisotropy = anisotropy; }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00169"></a>00169     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>    getNormalMapAnisotropy      ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNormalMapAnisotropy; }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     
<a name="l00175"></a>00175     <span class="keywordtype">void</span>            setNormalMapMipBias     (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mipBias) { mNormalMapMipBias = mipBias; }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00179"></a>00179     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>            getNormalMapMipBias     ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mNormalMapMipBias; }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="comment">// Protected types:</span>
<a name="l00184"></a>00184 <span class="keyword">protected</span>:
<a name="l00185"></a>00185     
<a name="l00186"></a>00186     <span class="comment">// Per light parameters.</span>
<a name="l00187"></a>00187     <span class="keyword">struct </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> LightParams
<a name="l00188"></a>00188     {
<a name="l00189"></a>00189         <a class="code" href="classOgre_1_1Light.html#a4f1dea084d1497c6f49e802ade940dbc" title="Defines the type of light.">Light::LightTypes</a>       mType;              <span class="comment">// Light type.      </span>
<a name="l00190"></a>00190         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mPosition;          <span class="comment">// Light position.</span>
<a name="l00191"></a>00191         <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutToLightDir;   <span class="comment">// Vertex shader output vertex position to light position direction (texture space).</span>
<a name="l00192"></a>00192         <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInToLightDir;    <span class="comment">// Pixel shader input vertex position to light position direction (texture space).</span>
<a name="l00193"></a>00193         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDirection;         <span class="comment">// Light direction.</span>
<a name="l00194"></a>00194         <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutDirection;    <span class="comment">// Vertex shader output light direction (texture space).</span>
<a name="l00195"></a>00195         <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInDirection;     <span class="comment">// Pixel shader input light direction (texture space).      </span>
<a name="l00196"></a>00196         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mAttenuatParams;    <span class="comment">// Attenuation parameters.</span>
<a name="l00197"></a>00197         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSpotParams;        <span class="comment">// Spot light parameters.</span>
<a name="l00198"></a>00198         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDiffuseColour;     <span class="comment">// Diffuse colour.</span>
<a name="l00199"></a>00199         <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSpecularColour;    <span class="comment">// Specular colour.</span>
<a name="l00200"></a>00200 
<a name="l00201"></a>00201     };
<a name="l00202"></a>00202 
<a name="l00203"></a>00203     <span class="keyword">typedef</span> vector&lt;LightParams&gt;::type               LightParamsList;
<a name="l00204"></a>00204     <span class="keyword">typedef</span> LightParamsList::iterator               LightParamsIterator;
<a name="l00205"></a>00205     <span class="keyword">typedef</span> LightParamsList::const_iterator         LightParamsConstIterator;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="comment">// Protected methods</span>
<a name="l00208"></a>00208 <span class="keyword">protected</span>:
<a name="l00209"></a>00209 
<a name="l00215"></a>00215     <span class="keywordtype">void</span>                    setTrackVertexColourType(<a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> type) { mTrackVertexColourType = type; }
<a name="l00216"></a>00216 
<a name="l00220"></a>00220     <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a>   getTrackVertexColourType()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTrackVertexColourType; }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00227"></a>00227     <span class="keywordtype">void</span>                    setLightCount           (<span class="keyword">const</span> <span class="keywordtype">int</span> lightCount[3]);
<a name="l00228"></a>00228 
<a name="l00233"></a>00233     <span class="keywordtype">void</span>                    getLightCount           (<span class="keywordtype">int</span> lightCount[3]) <span class="keyword">const</span>;
<a name="l00239"></a>00239     <span class="keywordtype">void</span>                    setSpecularEnable       (<span class="keywordtype">bool</span> enable) { mSpecularEnable = enable; }
<a name="l00240"></a>00240 
<a name="l00244"></a>00244     <span class="keywordtype">bool</span>                    getSpecularEnable       ()<span class="keyword"> const      </span>{ <span class="keywordflow">return</span> mSpecularEnable; }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00250"></a>00250     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveParameters           (ProgramSet* programSet);
<a name="l00251"></a>00251 
<a name="l00253"></a>00253     <span class="keywordtype">bool</span>                    resolveGlobalParameters     (ProgramSet* programSet);
<a name="l00254"></a>00254 
<a name="l00256"></a>00256     <span class="keywordtype">bool</span>                    resolvePerLightParameters   (ProgramSet* programSet);
<a name="l00257"></a>00257 
<a name="l00261"></a>00261     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            resolveDependencies     (ProgramSet* programSet);
<a name="l00262"></a>00262 
<a name="l00266"></a>00266     <span class="keyword">virtual</span> <span class="keywordtype">bool</span>            addFunctionInvocations  (ProgramSet* programSet);
<a name="l00267"></a>00267     
<a name="l00268"></a>00268 
<a name="l00272"></a>00272     <span class="keywordtype">bool</span>            addVSInvocation                     (Function* vsMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00273"></a>00273 
<a name="l00277"></a>00277     <span class="keywordtype">bool</span>            addVSIlluminationInvocation         (LightParams* curLightParams, Function* vsMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00278"></a>00278 
<a name="l00282"></a>00282     <span class="keywordtype">bool</span>            addPSNormalFetchInvocation      (Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00288"></a>00288     <span class="keywordtype">bool</span>            addPSGlobalIlluminationInvocation   (Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00289"></a>00289 
<a name="l00293"></a>00293     <span class="keywordtype">bool</span>            addPSIlluminationInvocation     (LightParams* curLightParams, Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00294"></a>00294 
<a name="l00298"></a>00298     <span class="keywordtype">bool</span>            addPSFinalAssignmentInvocation  (Function* psMain, <span class="keyword">const</span> <span class="keywordtype">int</span> groupOrder, <span class="keywordtype">int</span>&amp; internalCounter);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 <span class="comment">// Attributes.</span>
<a name="l00302"></a>00302 <span class="keyword">protected</span>:  
<a name="l00303"></a>00303     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                  mNormalMapTextureName;          <span class="comment">// The normal map texture name.</span>
<a name="l00304"></a>00304     <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a>   mTrackVertexColourType;         <span class="comment">// Track per vertex colour type.</span>
<a name="l00305"></a>00305     <span class="keywordtype">bool</span>                    mSpecularEnable;                <span class="comment">// Specular component enabled/disabled.</span>
<a name="l00306"></a>00306     LightParamsList         mLightParamsList;               <span class="comment">// Light list.</span>
<a name="l00307"></a>00307     <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span>          mNormalMapSamplerIndex;         <span class="comment">// Normal map texture sampler index.</span>
<a name="l00308"></a>00308     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>            mVSTexCoordSetIndex;            <span class="comment">// Vertex shader input texture coordinate set index.</span>
<a name="l00309"></a>00309     <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>           mNormalMapMinFilter;            <span class="comment">// The normal map min filter.</span>
<a name="l00310"></a>00310     <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>           mNormalMapMagFilter;            <span class="comment">// The normal map mag filter.</span>
<a name="l00311"></a>00311     <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a>           mNormalMapMipFilter;            <span class="comment">// The normal map mip filter.</span>
<a name="l00312"></a>00312     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>            mNormalMapAnisotropy;           <span class="comment">// The normal map max anisotropy value.</span>
<a name="l00313"></a>00313     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>                    mNormalMapMipBias;              <span class="comment">// The normal map mip map bias.</span>
<a name="l00314"></a>00314     NormalMapSpace          mNormalMapSpace;                <span class="comment">// The normal map space.</span>
<a name="l00315"></a>00315     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mWorldMatrix;                   <span class="comment">// World matrix parameter.</span>
<a name="l00316"></a>00316     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mWorldInvRotMatrix;             <span class="comment">// World matrix inverse rotation matrix parameter.</span>
<a name="l00317"></a>00317     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mCamPosWorldSpace;              <span class="comment">// Camera position in world space parameter.    </span>
<a name="l00318"></a>00318     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInPosition;                  <span class="comment">// Vertex shader input position parameter.</span>
<a name="l00319"></a>00319     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSWorldPosition;               <span class="comment">// Vertex shader world position parameter.</span>
<a name="l00320"></a>00320     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutView;                     <span class="comment">// Vertex shader output view vector (position in camera space) parameter.</span>
<a name="l00321"></a>00321     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInView;                      <span class="comment">// Pixel shader input view position (position in camera space) parameter.</span>
<a name="l00322"></a>00322     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInNormal;                    <span class="comment">// Vertex shader input normal.</span>
<a name="l00323"></a>00323     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInTangent;                   <span class="comment">// Vertex shader input tangent.</span>
<a name="l00324"></a>00324     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSTBNMatrix;                   <span class="comment">// Vertex shader local TNB matrix.</span>
<a name="l00325"></a>00325     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSLocalDir;                    <span class="comment">// Vertex shader local light direction.</span>
<a name="l00326"></a>00326     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mNormalMapSampler;              <span class="comment">// Normal map texture sampler parameter.</span>
<a name="l00327"></a>00327     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSNormal;                      <span class="comment">// Pixel shader normal parameter.</span>
<a name="l00328"></a>00328     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSInTexcoord;                  <span class="comment">// Vertex shader input texture coordinates.</span>
<a name="l00329"></a>00329     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mVSOutTexcoord;                 <span class="comment">// Vertex shader output texture coordinates.</span>
<a name="l00330"></a>00330     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSInTexcoord;                  <span class="comment">// Pixel shader input texture coordinates.</span>
<a name="l00331"></a>00331     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSTempDiffuseColour;           <span class="comment">// Pixel shader temporary diffuse calculation parameter.</span>
<a name="l00332"></a>00332     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSTempSpecularColour;          <span class="comment">// Pixel shader temporary specular calculation parameter.</span>
<a name="l00333"></a>00333     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSDiffuse;                     <span class="comment">// Pixel shader input/local diffuse parameter.  </span>
<a name="l00334"></a>00334     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSSpecular;                    <span class="comment">// Pixel shader input/local specular parameter. </span>
<a name="l00335"></a>00335     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSOutDiffuse;                  <span class="comment">// Pixel shader output diffuse parameter.   </span>
<a name="l00336"></a>00336     <a class="code" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>            mPSOutSpecular;                 <span class="comment">// Pixel shader output specular parameter.  </span>
<a name="l00337"></a>00337     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDerivedSceneColour;            <span class="comment">// Derived scene colour parameter.</span>
<a name="l00338"></a>00338     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mLightAmbientColour;            <span class="comment">// Ambient light colour parameter.</span>
<a name="l00339"></a>00339     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mDerivedAmbientLightColour;     <span class="comment">// Derived ambient light colour parameter.</span>
<a name="l00340"></a>00340     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceAmbientColour;          <span class="comment">// Surface ambient colour parameter.</span>
<a name="l00341"></a>00341     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceDiffuseColour;          <span class="comment">// Surface diffuse colour parameter.</span>
<a name="l00342"></a>00342     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceSpecularColour;         <span class="comment">// Surface specular colour parameter.</span>
<a name="l00343"></a>00343     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceEmissiveColour;         <span class="comment">// Surface emissive colour parameter.</span>
<a name="l00344"></a>00344     <a class="code" href="group__RTShader.html#gae0e6b89f6ed3986b0a87e2472e3ff7f1">UniformParameterPtr</a>     mSurfaceShininess;              <span class="comment">// Surface shininess parameter.</span>
<a name="l00345"></a>00345     <span class="keyword">static</span> Light            msBlankLight;                   <span class="comment">// Shared blank light.</span>
<a name="l00346"></a>00346 };
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00353"></a>00353 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> NormalMapLightingFactory : <span class="keyword">public</span> SubRenderStateFactory
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355 <span class="keyword">public</span>:
<a name="l00356"></a>00356 
<a name="l00360"></a>00360     <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp;   getType             () <span class="keyword">const</span>;
<a name="l00361"></a>00361 
<a name="l00365"></a>00365     <span class="keyword">virtual</span> SubRenderState* createInstance      (ScriptCompiler* compiler, PropertyAbstractNode* prop, Pass* pass, SGScriptTranslator* translator);
<a name="l00366"></a>00366 
<a name="l00370"></a>00370     <span class="keyword">virtual</span> <span class="keywordtype">void</span>            writeInstance       (MaterialSerializer* ser, SubRenderState* subRenderState, Pass* srcPass, Pass* dstPass);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372     
<a name="l00373"></a>00373 <span class="keyword">protected</span>:
<a name="l00374"></a>00374 
<a name="l00378"></a>00378     <span class="keyword">virtual</span> SubRenderState* createInstanceImpl  ();
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 };
<a name="l00382"></a>00382 
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="preprocessor">#endif</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00391"></a>00391 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
